// -----------------------------------------------
// Copyright © Sirius. All rights reserved.
// CreateTime: 2022/4/28   12:4:42
// -----------------------------------------------
// -----------------------------------------------
// Copyright © Sirius. All rights reserved.
// CreateTime: 2022/4/24   17:1:7
// -----------------------------------------------

#if UNITY_EDITOR

using System;
using UnityEditor;
using UnityEngine;

public class ZhaoluEditor
{
        public static string path = $"{Application.dataPath}/../../Tools/";
        
    [MenuItem("Zhaolu/Luban Export")]
    private static void LubanExport()
    {
#if UNITY_EDITOR_OSX
        string ShellPath = $"{Application.dataPath}/../../Tools/ShellCommands";
        ShellHelper.Run("sh Git/UpdateLuban.sh", ShellPath);
#endif
         path = $"{Application.dataPath}/../../Tools/Luban";
        Debug.Log(path);
#if UNITY_EDITOR_OSX
        ShellHelper.Run("sh gen_code_bin.sh", path);
#elif UNITY_EDITOR_WIN
        ShellHelper.Run("gen_code_bin_ForUnity.bat", path);
#endif
        AssetDatabase.Refresh();
    }
    
    [MenuItem("Zhaolu/Luban Clean Gen")]
    private static void LubanCleanGen()
    {

#if UNITY_EDITOR_OSX
            path = $"{Application.dataPath}/../../Tools/ShellCommands";
            ShellHelper.Run("sh Git/CheckoutGenerate_Luban.sh", path);
            return;
#endif
            try
            {
                    ShellHelper.Run("CheckoutGenerate_Luban.bat", path);
            }
            catch (Exception e)
            {
                    Console.WriteLine(e);
                    throw;
            }
    }

    [MenuItem("Zhaolu/Proto Export")]
    private static void ProtoExport()
    {
#if UNITY_EDITOR_OSX
        path = $"{Application.dataPath}/../../Tools/ShellCommands";
        ShellHelper.Run("sh Git/UpdateProto.sh", path);
        return;
#endif
        path = $"{Application.dataPath}/../../Tools/Tools/bin/Debug/net6.0";
        ShellHelper.Run("dotnet Tools.dll", path);
        AssetDatabase.Refresh();
    }
    
    [MenuItem("Zhaolu/Proto Clean Gen")]
    private static void ProtoCleanGen()
    {
#if UNITY_EDITOR_OSX
            path = $"{Application.dataPath}/../../Tools/ShellCommands";
            ShellHelper.Run("sh Git/CheckoutGenerate_Proto.sh", path);
            return;
#endif
            ShellHelper.Run("CheckoutGenerate_Proto.bat", path);
    }
    
        
    [MenuItem("Zhaolu/FGUI Clean Gen")]
    private static void FGUICleanGen()
    {
#if UNITY_EDITOR_OSX
            path = $"{Application.dataPath}/../../Tools/ShellCommands";
            ShellHelper.Run("sh Git/CheckoutGenerate_Fui.sh", path);
            return;
#endif
            ShellHelper.Run("CheckoutGenerate_Fui.bat", path);
    }
}

#endif